<template>
  <div>
    <hero-section
      :title="$t('blood_donation_title')"
      :subtitle="$t('blood_donation_subtitle')"
    />
    <section class="container">
      <main class="columns">
        <div class="column is-three-quarters-desktop">
          <article
            v-if="stats"
            class="is-child notification"
          >
            <p class="title">
              {{ $t('goal') }}
            </p>
            <div class="content">
              <div class="progress is-large">
                <div
                  v-if="stats.blood.count"
                  class="bar is-danger"
                  :style="{ width: stats.blood.count + '%' }"
                  :title="$t('blood_donations_count', { count: stats.blood.count, quantity: 0 })"
                >
                  {{ stats.blood.count }}
                </div>
                <div
                  v-if="stats.plasma.count"
                  class="bar is-info"
                  :style="{ width: stats.plasma.count + '%' }"
                  :title="$t('plasma_donations_count', { count: stats.plasma.count, quantity: 0 })"
                >
                  {{ stats.plasma.count }}
                </div>
                <div
                  v-if="stats.platelets.count"
                  class="bar is-warning"
                  :style="{ width: stats.platelets.count + '%' }"
                  :title="$t('platelets_donations_count', { count: stats.platelets.count, quantity: 0 })"
                >
                  {{ stats.platelets.count }}
                </div>
              </div>
            </div>
          </article>
          <article class="notification is-link">
            <p class="title">
              {{ $t('last_five_donations') }}
            </p>
            <div class="content">
              <table>
                <thead>
                  <tr>
                    <th>{{ $t('date') }}</th>
                    <th>{{ $t('type') }}</th>
                    <th>{{ $t('quantity_given') }}</th>
                    <th class="is-narrow">
                      {{ $t('hematoma') }}
                    </th>
                  </tr>
                </thead>
                <tbody>
                  <tr
                    v-for="donation in history"
                    :key="donation.id"
                  >
                    <td>{{ donation.date }}</td>
                    <td v-if="donation.type === 'blood'">
                      {{ $t('blood') }}
                    </td>
                    <td v-else-if="donation.type === 'platelets'">
                      {{ $t('platelets') }}
                    </td>
                    <td v-else-if="donation.type === 'plasma'">
                      {{ $t('plasma') }}
                    </td>
                    <td>± {{ donation.quantity }} ml</td>
                    <td
                      v-if="donation.hematoma"
                      class="is-narrow"
                    >
                      {{ $t('yes') }}
                    </td>
                    <td
                      v-else
                      class="is-narrow"
                    >
                      {{ $t('no') }}
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
          </article>
        </div>
        <div class="column">
          <article class="notification is-success">
            <div class="title">
              {{ $t('next_possible_donation') }}
            </div>
            <div
              v-if="stats.latest.type === 'blood'"
              class="content is-centered"
            >
              <donation-type-table
                :weeks-old="weeksOld"
                :next-donation="nextDonation"
                :blood-wait="8"
                :plasma-wait="2"
                :platelets-wait="4"
              />
            </div>
            <div
              v-else-if="stats.latest.type === 'plasma'"
              class="content is-large is-centered"
            >
              <donation-type-table
                :weeks-old="weeksOld"
                :next-donation="nextDonation"
                :blood-wait="2"
                :plasma-wait="2"
                :platelets-wait="2"
              />
            </div>
            <div
              v-else-if="stats.latest.type === 'platelets'"
              class="content is-large is-centered"
            >
              <donation-type-table
                :weeks-old="weeksOld"
                :next-donation="nextDonation"
                :blood-wait="4"
                :plasma-wait="2"
                :platelets-wait="4"
              />
            </div>
          </article>
          <article class="notification is-info">
            <div class="title">
              {{ $t('statistics') }}
            </div>
            <div class="content">
              <ul>
                <li>
                  {{ $t('total_donations', { count: stats.total.count, quantity: stats.total.quantity }) }}:
                  <ul>
                    <li v-if="stats.blood.count">
                      {{ $t('blood_donations_count', { count: stats.blood.count, quantity: stats.blood.sum.quantity }) }}
                    </li>
                    <li v-if="stats.plasma.count">
                      {{ $t('plasma_donations_count', { count: stats.plasma.count, quantity: stats.plasma.sum.quantity }) }}
                    </li>
                    <li v-if="stats.platelets.count">
                      {{ $t('platelets_donations_count', { count: stats.platelets.count, quantity: stats.platelets.sum.quantity }) }}
                    </li>
                  </ul>
                </li>
              </ul>
            </div>
          </article>
        </div>
      </main>
    </section>
  </div>
</template>

<script setup lang="ts">
const {
  fetchHistory,
  fetchStats,
  processStats,
  calculateWeeksOld,
  formatNextDonationDate,
} = useBloodDonation()

const [history, stats] = await Promise.all([fetchHistory(), fetchStats().then(processStats)])

const previousDonation = new Date(stats.latest.date)
const weeksOld = calculateWeeksOld(previousDonation)
const nextDonation = (weeksToWait: number) => formatNextDonationDate(previousDonation, weeksToWait)
</script>

<style lang="scss" scoped>
@use 'sass:list';
@use "bulma/sass/utilities/derived-variables" as *;
@use "bulma/sass/utilities/initial-variables" as *;

$progress-bar-background-color: $border-weak !default;
$progress-value-background-color: $text !default;
$progress-border-radius: $radius-rounded !default;
$progress-indeterminate-duration: 1.5s !default;
$progress-colors: $colors !default;

main {
  margin: 20px 0;
}

div.progress {
  background: $progress-value-background-color;
  > .bar {
    height: 100%;
    float: left;
    text-align: center;
    color: $text-invert;
    font-size: $size-small;
    padding-top: calc($size-small / 4);
    padding-bottom: calc($size-small / 4);
    @each $name, $pair in $progress-colors {
      $color: list.nth($pair, 1);
      &.is-#{$name} {
        background-color: $color;
      }
    }

  }
}
</style>
